diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java
new file mode 100644
index 000000000..6c0b4c963
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java
@@ -0,0 +1,187 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+
+public class BlockLogicRubyglassGrowth extends BlockLogic {
+    public BlockLogicRubyglassGrowth(Block<?> block) {
+        super(block, Materials.PLANT);
+        block.setTicking(true);
+    }
+
+    public static final int MASK_DIRECTION = 0b0000_0111;
+
+    @Override
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        final @NotNull TilePos temp = new TilePos();
+        if((side == Side.NORTH && world.isBlockNormalCube(tilePos.south(temp)))
+            || side == Side.SOUTH && world.isBlockNormalCube(tilePos.north(temp))
+            || (side == Side.EAST && world.isBlockNormalCube(tilePos.west(temp)))
+            || (side == Side.WEST && world.isBlockNormalCube(tilePos.east(temp)))
+            || (side == Side.BOTTOM && world.isBlockNormalCube(tilePos.up(temp)))
+            || (side == Side.TOP && world.isBlockNormalCube(tilePos.down(temp)))) {
+            world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.getDirection()));
+        } else {
+            world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, getOrientation(world, tilePos)));
+        }
+    }
+
+    private Direction getOrientation(World world, TilePosc tilePos)
+    {
+        final @NotNull TilePos temp = new TilePos();
+        if(world.isBlockNormalCube(tilePos.west(temp)))
+        {
+            return Side.EAST.getDirection();
+        }
+        if(world.isBlockNormalCube(tilePos.east(temp)))
+        {
+            return Side.WEST.getDirection();
+        }
+        if(world.isBlockNormalCube(tilePos.south(temp)))
+        {
+            return Side.NORTH.getDirection();
+        }
+        if (world.isBlockNormalCube(tilePos.north(temp))){
+            return  Side.SOUTH.getDirection();
+        }
+        if (world.isBlockNormalCube(tilePos.down(temp))){
+            return  Side.TOP.getDirection();
+        }
+        if (world.isBlockNormalCube(tilePos.up(temp))){
+            return  Side.BOTTOM.getDirection();
+        }
+        return Side.TOP.getDirection();
+    }
+
+    @Override
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        boolean invalid;
+        int meta = world.getBlockData(tilePos);
+        Direction dir = metaToDirection(meta);
+        final @NotNull TilePos temp = new TilePos();
+        invalid = switch (dir) {
+            case EAST -> !world.isBlockNormalCube(tilePos.west(temp));
+            case WEST -> !world.isBlockNormalCube(tilePos.east(temp));
+            case SOUTH -> !world.isBlockNormalCube(tilePos.north(temp));
+            case NORTH -> !world.isBlockNormalCube(tilePos.south(temp));
+            case DOWN -> !world.isBlockNormalCube(tilePos.up(temp));
+            case UP -> !world.isBlockNormalCube(tilePos.down(temp));
+            default -> false;
+        };
+        if(invalid)
+        {
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
+        }
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public @Nullable AABBd getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return null;
+    }
+
+    public boolean mayPlaceOnBlockAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return world.isBlockNormalCube(tilePos);
+    }
+
+    @Override
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final @NotNull TilePos temp = new TilePos();
+        if(mayPlaceOnBlockAt(world, tilePos.south(temp)))
+        {
+            return true;
+        }
+        if(mayPlaceOnBlockAt(world, tilePos.north(temp)))
+        {
+            return true;
+        }
+        if(mayPlaceOnBlockAt(world, tilePos.west(temp)))
+        {
+            return true;
+        }
+        if(mayPlaceOnBlockAt(world, tilePos.east(temp)))
+        {
+            return true;
+        }
+        if(mayPlaceOnBlockAt(world, tilePos.up(temp)))
+        {
+            return true;
+        }
+        return mayPlaceOnBlockAt(world, tilePos.down(temp));
+    }
+
+    @Override
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        final @NotNull TilePos temp = new TilePos();
+        return world.isBlockNormalCube(tilePos.south(temp))
+            || world.isBlockNormalCube(tilePos.north(temp))
+            || world.isBlockNormalCube(tilePos.west(temp))
+            || world.isBlockNormalCube(tilePos.east(temp))
+            || world.isBlockNormalCube(tilePos.up(temp))
+            || world.isBlockNormalCube(tilePos.down(temp));
+    }
+
+    public static void setDefaultDirection(World world, TilePosc tilePos)
+    {
+        final @NotNull TilePos temp = new TilePos();
+        if(world.isClientSide)
+        {
+            return;
+        }
+        Direction direction = Direction.UP;
+        if(world.isBlockNormalCube(tilePos.north(temp)))
+        {
+            direction = Direction.SOUTH;
+        }
+        else if(world.isBlockNormalCube(tilePos.south(temp)))
+        {
+            direction = Direction.NORTH;
+        }
+        else if(world.isBlockNormalCube(tilePos.west(temp)))
+        {
+            direction = Direction.EAST;
+        }
+        else if(world.isBlockNormalCube(tilePos.east(temp)))
+        {
+            direction = Direction.WEST;
+        }
+        else if(world.isBlockNormalCube(tilePos.up(temp)))
+        {
+            direction = Direction.DOWN;
+        }
+        world.setBlockDataNotify(tilePos, direction.getId());
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED) };
+    }
+
+    public static Direction metaToDirection(int meta) {
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java
new file mode 100644
index 000000000..8d616a0f7
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulcatcher.java
@@ -0,0 +1,45 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicSoulcatcher extends BlockLogicFlower {
+
+    public BlockLogicSoulcatcher(final @NotNull Block<?> block) {
+        super(block);
+        final float f = 0.4F;
+        this.setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
+    }
+
+    @Override
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
+        entity.xd *= 0.4D;
+        entity.zd *= 0.4D;
+    }
+
+    @Override
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return this.mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
+    }
+
+    @Override
+    public boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block.isSolidRender();
+    }
+
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int meta, final @Nullable TileEntity tileEntity) {
+        return switch (dropCause) {
+            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[] { new ItemStack(this) };
+            default -> null;
+        };
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index ab07439c0..4880f4825 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -64,7 +64,7 @@ public class BlockLogicSponge extends BlockLogic {
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
             Block<?> b = world.getBlockType(tilePos.add(dir, queryPos));
-            if (b == Blocks.COBBLE_NETHERRACK_IGNEOUS || Blocks.hasTag(b, BlockTags.IS_LAVA)) return true;
+            if (b == Blocks.MAGMA || Blocks.hasTag(b, BlockTags.IS_LAVA)) return true;
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
new file mode 100644
index 000000000..2f1fcc15b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -0,0 +1,41 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+
+import java.util.List;
+import java.util.Random;
+
+public class BlockLogicThermalVent
+    extends BlockLogic {
+
+    public BlockLogicThermalVent(final @NotNull Block<?> block) {
+        super(block, Materials.STONE);
+
+    }
+
+    @Override
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
+
+        final double xPos = (double) tilePos.x() + 0.5D;
+        final double yPos = (double) tilePos.y() + 1.125D;
+        final double zPos = (double) tilePos.z() + 0.5D;
+
+        TilePos queryPos = new TilePos();
+        tilePos.up(queryPos);
+
+        if(world.isAirBlock(queryPos)){
+            world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 32);
+        }
+
+
+    }
+
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index a4d30ebe9..17940f66e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -411,9 +411,9 @@ public final class Blocks {
     public static final @NotNull Block<?> GRAVEL = register("gravel", "minecraft:block/gravel", 251, BlockLogicGravel::new)
         .withSound(BlockSounds.GRAVEL).withHardness(0.6F)
         .withTags(BlockTags.MINEABLE_BY_SHOVEL);
-    public static final @NotNull Block<?> SULFUR = register("sulfur", "minecraft:block/sulfur", 252, (b) -> new BlockLogic(b, Materials.SAND))
+    public static final Block<?> BRIMSAND = register("brimsand", "minecraft:block/brimsand", 252, (b) -> new BlockLogic(b, Materials.SAND))
             .withSound(BlockSounds.SAND).withHardness(0.7F)
-        .withTags(BlockTags.MINEABLE_BY_SHOVEL);
+        .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK);
 
     public static final @NotNull Block<?> BEDROCK = register("bedrock", "minecraft:block/bedrock", 260, (b) -> new BlockLogicBedrock(b, Materials.STONE))
         .withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F).withImmovableFlagSet()
@@ -1067,13 +1067,13 @@ public final class Blocks {
 
     public static final @NotNull Block<?> COBBLE_NETHERRACK = register("cobble.netherrack", "minecraft:block/cobble_netherrack", 800, (b) -> new BlockLogicCobble(b, Materials.NETHERRACK, null))
         .withSound(BlockSounds.STONE).withHardness(0.4F)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
-    public static final @NotNull Block<?> COBBLE_NETHERRACK_IGNEOUS = register("cobble.netherrack.igneous", "minecraft:block/cobble_netherrack_igneous", 801, BlockLogicNetherrackIgneous::new)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.GROWS_RUBYGLASS);
+    public static final @NotNull Block<?> MAGMA = register("magma", "minecraft:block/magma", 801, BlockLogicMagma::new)
         .withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT);
-    public static final @NotNull Block<?> COBBLE_NETHERRACK_MOSSY = register("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, (b) -> new BlockLogicCobble(b, Materials.NETHERRACK, null))
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> COBBLE_NETHERRACK_CRYSTALLINE = register("cobble.netherrack.crystalline", "minecraft:block/cobble_netherrack_mossy", 802, (b) -> new BlockLogicCobble(b, Materials.NETHERRACK, null))
         .withSound(BlockSounds.STONE).withHardness(0.4F)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.GROWS_FLOWERS, BlockTags.INFINITE_BURN);
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.GROWS_FLOWERS, BlockTags.INFINITE_BURN, BlockTags.GROWS_RUBYGLASS);
     public static final @NotNull Block<?> NETHERRACK = register("netherrack", "minecraft:block/netherrack", 803, (b) -> new BlockLogicStone(b, Blocks.COBBLE_NETHERRACK, Materials.NETHERRACK))
         .withSound(BlockSounds.STONE).withHardness(0.32F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
@@ -1105,17 +1105,24 @@ public final class Blocks {
 
     public static final @NotNull Block<?> GLOWSTONE = register("glowstone", "minecraft:block/glowstone", 820, (b) -> new BlockLogicGlowStone(b, Materials.STONE))
         .withSound(BlockSounds.GLASS).withHardness(0.3F).withLightEmission(1.0F).withOverrideColor(MaterialColor.paintedYellow)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT);
-    public static final @NotNull Block<?> CRYSTAL = register("crystal", "minecraft:block/crystal", 821, (b) -> new BlockLogicCrystal(b))
-        .withSound(BlockSounds.GLASS).withLightEmission(0.8F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final @NotNull Block<?> CRYSTAL_STALK = register("crystal.stalk", "minecraft:block/crystal_stalk", 822, (b) -> new BlockLogicStalk(b))
+    public static final Block<?> RUBYGLASS = register("rubyglass", "minecraft:block/rubyglass", 821, (b) -> new BlockLogicRubyglass(b))
+        .withSound(BlockSounds.GLASS).withHardness(0.3F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> RUBYGLASS_PURE = register("rubyglass.pure", "minecraft:block/rubyglass_pure", 822, (b) -> new BlockLogicTransparent(b, Materials.STONE))
+        .withSound(BlockSounds.GLASS).withHardness(0.3F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> RUBYGLASS_SPROUT = register("rubyglass.growth", "minecraft:block/rubyglass_growth", 823, (b) -> new BlockLogicRubyglassGrowth(b))
         .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final @NotNull Block<?> NETHERRACK_CRYSTALLINE = register("netherrack.crystalline", "minecraft:block/netherrack_crystalline", 823, (b) -> new BlockLogic(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block<?> RUBYGLASS_CIRCUIT = register("rubyglass.circuit", "minecraft:block/rubyglass_circuit", 824, (b) -> new BlockLogic(b, Materials.STONE))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withHardness(0.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN);
 
+    public static final Block<?> RUBYGLASS_BUD = register("rubyglass.bud", "minecraft:block/rubyglass_bud", 825, (b) -> new BlockLogicRubyglassCrop(b))
+            .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+
     public static final @NotNull Block<BlockLogicPortal> PORTAL_NETHER = register("portal.nether", "minecraft:block/portal_nether", 830, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.NETHER, Blocks.OBSIDIAN, Blocks.FIRE))
         .withSound(BlockSounds.GLASS).withHardness(-1F).withLightEmission(0.75F).withOverrideColor(MaterialColor.paintedPurple).withDisabledStats()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
@@ -1298,6 +1305,24 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(1.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
 
+    public static final Block<BlockLogicThermalVent> THERMAL_VENT = register("vent", "minecraft:block/thermal_vent", 1025, BlockLogicThermalVent::new)
+            .withSound(BlockSounds.STONE).withHardness(1.5F).withTags(BlockTags.MINEABLE_BY_PICKAXE);
+
+    public static final Block<?> BONE_PILE = register("bone_pile", "minecraft:block/bone_pile", 1030, BlockLogicBonepile::new)
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withOverrideColor(MaterialColor.marble)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block<?> SOULCATCHER = register("soul_catcher", "minecraft:block/soul_catcher", 1031, BlockLogicSoulcatcher::new)
+            .withSound(BlockSounds.GRAVEL).withHardness(1.0F).withOverrideColor(MaterialColor.sand)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.PLANTABLE_IN_JAR);
+
+    public static final Block<?> GLOOMSTONE = register("gloomstone", "minecraft:block/gloomstone", 1032, (b) -> new BlockLogicStone(b, Blocks.COBBLE_GLOOMSTONE, Materials.BASALT))
+            .withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
+            .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> COBBLE_GLOOMSTONE = register("cobble.gloomstone", "minecraft:block/cobble_gloomstone", 1033, (b) -> new BlockLogicCobble(b, Materials.BASALT, () -> null))
+            .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+
+
     public static final @NotNull Block<BlockLogic> MATCHER = register("matcher", "minecraft:block/matcher", 1040, (b) -> new BlockLogicMatcher(b, false))
         .withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
index bf4a80095..47d0f217d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
@@ -40,19 +40,25 @@ public class FluidLava
     public boolean checkForHarden(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Material encountered) {
         if (encountered == Materials.WATER) {
             final int data = world.getBlockData(tilePos) & 0x0F;
-            if (data == 0) {
-                if (world.dimension == Dimension.NETHER) {
-                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_NETHERRACK_IGNEOUS);
+
+            if (world.dimension == Dimension.NETHER) {
+                if (data == 0) {
+                    world.setBlockTypeNotify(tilePos, Blocks.MAGMA);
                 } else {
-                    world.setBlockTypeNotify(tilePos, Blocks.OBSIDIAN);
+                    world.setBlockTypeNotify(tilePos, Blocks.NETHERRACK);
                 }
-            } else if (data <= 2) {
-                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_GRANITE);
-            } else if (data <= 4) {
-                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_STONE);
             } else {
-                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_BASALT);
+                if (data == 0) {
+                    world.setBlockTypeNotify(tilePos, Blocks.OBSIDIAN);
+                } else if (data <= 2) {
+                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_GRANITE);
+                } else if (data <= 4) {
+                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_STONE);
+                } else {
+                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_BASALT);
+                }
             }
+
             BlockLogicFluid.fizz(world, tilePos);
             return true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index 3ce94ffda..dc72e0456 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -46,9 +46,13 @@ public class FluidWater
         if (encountered == Materials.LAVA) {
             final int data = world.getBlockData(tilePos) & 0x0F;
             if (data == 0) {
-                world.setBlockTypeNotify(tilePos, Blocks.COBBLE_LIMESTONE);
-                BlockLogicFluid.fizz(world, tilePos);
+                if (world.dimension == Dimension.NETHER) {
+                    world.setBlockTypeNotify(tilePos, Blocks.NETHERRACK);
+                } else {
+                    world.setBlockTypeNotify(tilePos, Blocks.COBBLE_LIMESTONE);
+                }
             }
+            BlockLogicFluid.fizz(world, tilePos);
             return true;
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index 9b7f2e1b7..7bcd0ea07 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -149,7 +149,7 @@ public abstract class BlockTags
      */
     public static final Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
     /**
-     * Block allows fire to burn forever on it {@link BlockFire BlockFire}
+     * Block allows fire to burn forever on it {@link BlockLogicFire BlockFire}
      */
     public static final Tag<Block<?>> INFINITE_BURN_COLD = Tag.of("infinite_burn_cold");
     /**
@@ -185,6 +185,16 @@ public abstract class BlockTags
      */
     public static final Tag<Block<?>> OVERRIDE_FRICTION = Tag.of("override_friction");
 
+    /**
+     * Determines what blocks features like sulfur pools and thermal vents can replace on generation.
+     */
+    public static final Tag<Block<?>> NETHER_SURFACE_BLOCK = Tag.of("nether_surface_block");
+
+    /**
+     * Determines what blocks rubyglass buds can be grown on.
+     */
+    public static final Tag<Block<?>> GROWS_RUBYGLASS = Tag.of("grows_rubyglass");
+
     public static List<Tag<Block<?>>> TAG_LIST;
 
     static
diff --git a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
index b83ef34f1..31915e014 100644
--- a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
+++ b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
@@ -4,13 +4,9 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 
-import java.util.HashMap;
-import java.util.Map;
-
 public abstract class LegacyBiomes
 {
     private static final Int2ObjectMap<Biome> idToBiomeMap = new Int2ObjectArrayMap<>();
@@ -48,7 +44,7 @@ public abstract class LegacyBiomes
         register(Biomes.OVERWORLD_GLACIER, 11);
         register(Biomes.OVERWORLD_TUNDRA, 12);
         register(Biomes.OVERWORLD_MEADOW, 13);
-        register(Biomes.NETHER_NETHER, 14);
+        register(Biomes.NETHER_CRAG, 14);
         register(Biomes.DRIFT_DRIFT, 15);
         register(Biomes.OVERWORLD_BIRCH_FOREST, 16);
         register(Biomes.OVERWORLD_RETRO, 17);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index 3a87f4948..1733c2818 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -18,6 +18,15 @@ public class EntityLightning extends Entity {
     public long seed;
     private int flashes;
 
+    public float pitch = 0.0f;
+    public float yaw = 0.0f;
+    public float r = 0.9f;
+    public float g = 0.9f;
+    public float b = 1.0f;
+    public float scale = 1.0f;
+    public boolean silent = false;
+    public boolean flipped = false;
+
     public EntityLightning(World world) {
         this(world, 0, 0, 0);
     }
@@ -34,7 +43,7 @@ public class EntityLightning extends Entity {
     @Override
     public void tick() {
         super.tick();
-        if (this.life == 2) {
+        if (this.life == 2 && !this.silent) {
             this.world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, this.x, this.y, this.z, "ambient.weather.thunder", 10000F, 0.8F + this.random.nextFloat() * 0.2F);
             this.world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, this.x, this.y, this.z, "random.explode", 2.0F, 0.5F + this.random.nextFloat() * 0.2F);
             for (int i = 0; i < this.world.entities.size(); i++) {
@@ -52,7 +61,7 @@ public class EntityLightning extends Entity {
                 this.flashes--;
                 this.life = 1;
                 this.seed = this.random.nextLong();
-                if (this.world.areBlocksLoaded(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z), 10)) {
+                if (!this.silent && this.world.areBlocksLoaded(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z), 10)) {
                     int i = MathHelper.floor(this.x);
                     int j = MathHelper.floor(this.y);
                     int k = MathHelper.floor(this.z);
@@ -62,7 +71,7 @@ public class EntityLightning extends Entity {
                 }
             }
         }
-        if (this.life >= 0) {
+        if (!this.silent && this.life >= 0) {
             double radius = 3D;
             List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, new AABBd(this.x - radius, this.y - radius, this.z - radius, this.x + radius, this.y + 6D + radius, this.z + radius));
             for (Entity entity : list) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 41e12751f..bcb6319a7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -4,6 +4,7 @@ import com.b100.utils.StringUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -22,6 +23,7 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
@@ -880,6 +882,17 @@ public abstract class Mob extends Entity {
         return false;
     }
 
+    public boolean hurtByNetherWater() {
+        return true;
+    }
+
+    @Override
+    public void waterHurt() {
+        if (this.hurtByNetherWater()) {
+            super.waterHurt();
+        }
+    }
+
     public void onLivingUpdate() {
         if (this.newPosRotationIncrements > 0) {
             double d = this.x + (this.newPosX - this.x) / (double) this.newPosRotationIncrements;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index 4ddad70a8..d38f53965 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -438,7 +438,13 @@ public class MobFireflyCluster extends MobFlying
         },
             new float[]{0.67f, 1f, 0.99f}));
         public static FireflyColor RED = register(new FireflyColor(3, "fireflyRed", new Biome[]{
-            Biomes.NETHER_NETHER
+            Biomes.NETHER_CRAG,
+            Biomes.NETHER_SHELF,
+            Biomes.NETHER_SULFUR_POOLS,
+            Biomes.NETHER_VOLCANIC_ISLANDS,
+            Biomes.NETHER_CRYSTAL_FOREST,
+            Biomes.NETHER_CRYSTAL_FIELD,
+            Biomes.NETHER_OLD_WORLD
         },
             new float[]{1f, 0.25f, 0.25f}));
 
